
#ifndef _ClassCrossword_
#define _ClassCrossword_

#include "CCell.h"

//    1000 
#define MaxCrosswordSize	1000

class CCrossword : public CObject
{
public:
	CCrossword ();
	~CCrossword ();
	void DeleteContent (void);
	
	//  
	BOOL Load (CArchive& ar);
	BOOL Save (CArchive& ar);
	
	//    
	BOOL TestAdd (int newType, int newX, int newY, int newLength);

	//      
	BOOL Add (int newType, int newX, int newY, int newLength, LPCTSTR newWord = "");
	
	//    
	BOOL TestRemove (int Type, int X, int Y);

	//    
	BOOL Remove (int Type, int X, int Y);

	//  
	void Link (void);

	//    src       index ?
	BOOL IsLinked (CCell &src, long index);

	//  :       
	//  Link()  Count()
	void Sort (void);

	//  -   
	void Count (void);

	//      
	void ClearLinks (void);

	//      
	void ClearChains (void);

	//   
	void GetRect (CRect &rect);

	CCell *CellsList;	//   
	long CellsListSize;	//   

	//   -   (MinWordSize + index)
	long SizesCounter [MaxWordSize - MinWordSize + 1];
	
	//   -   (MinWordSize + index)
	long dimDictionarySizesCounter [MaxWordSize - MinWordSize + 1];
};

#endif
