
#ifndef _ClassCell_
#define _ClassCell_

#define NullCell	-1
#define NullWord	-1

//   
#define Vertical	0
#define Horizontal	1

//   
#define MaxX	200
#define MinX	0
#define MaxY	200
#define MinY	0

//     
#define MaxWordSize	30
#define MinWordSize	2

typedef struct
{
	long CellNumber;
	int CharNumber;
} CrossStruct;

class CCell : public CObject
{
public:
    CCell ();
    CCell (const CCell& c);
	~CCell ();
    
	const CCell& operator= (const CCell& c);
	void DeleteContent (void);
	void Set (int newType, int newX, int newY, int newLength, LPCTSTR newWord = "");

	//   
	void ClearCrossList (void);

	CString Word;		//   
	long NumberOfWord;	//     ( NullWord)

	int Type;			//   ( ,  )
	int X, Y;			//  
	int Length;			//    
	CrossStruct *CrossList;	//  
	int CrossCounter;	//     
};

#endif
