// CrossMasterView.h : interface of the CCrossMasterView class
//
/////////////////////////////////////////////////////////////////////////////

class CCrossMasterView : public CScrollView
{
protected: // create from serialization only
	CCrossMasterView();
	DECLARE_DYNCREATE(CCrossMasterView)

// Attributes
public:
	CCrossMasterDoc* GetDocument();

	CRect CursorRect;	//     .  

// Operations
public:
	void MoveCursor (int x, int y);
	void DrawCursor (CRect &rectCursor, CDC *pDC, COLORREF rgb);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCrossMasterView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CCrossMasterView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CCrossMasterView)
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	virtual void OnInitialUpdate();
};

#ifndef _DEBUG  // debug version in CrossMasterView.cpp
inline CCrossMasterDoc* CCrossMasterView::GetDocument()
   { return (CCrossMasterDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
